"""
Tests a given NN for the simple problem with 4 nodes, using traci.
"""
import neat
import random
import sys
from typing import List

import sumolib
from sumolib.net import Edge
from sumolib.net import Net
from sumolib.net import Node
from traci._route import RouteDomain

from conf import settings

import traci


class RouteNetwork(object):
    """" A sumo network of routes. """
    def __init__(self, xml_file: str):
        self.net = sumolib.net.readNet(xml_file)
        routes: RouteDomain = traci.route
        self.routes: List[Route] = [Route(i, self.net) for i in routes.getIDList()]


class Route(object):
    """" A route in traci. """
    def __init__(self, route_id: str, net: Net):
        self.id = route_id
        self.net = net
        routes: RouteDomain = traci.route
        self.edges: List[Edge] = [self.net.getEdge(i) for i in routes.getEdges(route_id)]

    @property
    def from_node(self) -> Node:
        """" Start node of the route. """
        return self.edges[0].getFromNode()

    @property
    def to_node(self) -> Node:
        """" Goal node of the route. """
        return self.edges[-1].getToNode()
