"""
Global Settings
"""
from pathlib import Path

from typing import Tuple

# Global project settings
BASE_DIR: Path = Path(__file__).resolve().parents[1]  # Parent of conf directory
CONF_DIR: Path = BASE_DIR.joinpath('conf')  # Conf directory

# Performance
# How many times to run a network to evolute (using random inputs).
TEST_RUNS_PER_NET: int = 10
# Number of times to evolute the network
NUMBER_EVOLUTIONS = 10

# Model settings
DESTINATION_NODES: int = 1
STARTING_NODES: int = 5
TIME_STEPS: int = 10  # Number of time steps in the output matrix
INITIAL_CARS_PER_CITY = 3

GOAL: int = 3  # Semantic number for the goal node
# Tuples because these are immutable.
ROAD_CONNECTIONS: Tuple[Tuple[int, int]] = (
    (0, GOAL),
    (2, GOAL),
    (1, GOAL),
    (0, 2),
    (2, 0),
    (2, 1),
    (1, 2),
    (1, 0),
    (0, 1)
)
